<?php
    /*
    Plugin Name: Egito plugin
    Plugin URI: https://egito.pl
    Description: Integracja z systemem Egito
    Author: Egito
    Version: 2.4.3
    Author URI: https://egito.pl
    */

	require('functions.php');
// create custom plugin settings menu
add_action('admin_menu', 'ds_api_plugin_create_menu');

function ds_api_plugin_create_menu() {

	//create new top-level menu
	//add_menu_page('Egito Settings Page', 'Egito Settings', 'administrator', __FILE__, 'egito_plugin_connection_settings_page' , plugins_url('/images/icon.png', __FILE__) );
	add_menu_page('Egito Settings Page', 'Egito Settings', 'administrator', __FILE__, 'egito_plugin_connection_settings_page' , 'dashicons-admin-generic');
	add_submenu_page( __FILE__, 'Egito Settings Page', 'Integracja Contact Form 7', 'administrator', 'egito_plugin_form_settings_page', 'egito_plugin_form_settings_page' );

	//call register settings function
	add_action( 'admin_init', 'register_egito_plugin_settings' );
}


function register_egito_plugin_settings() {
	//register our settings
	register_setting( 'ds-api-plugin-connection-settings-group', 'egito_user_name' );
	register_setting( 'ds-api-plugin-connection-settings-group', 'egito_password' );
	register_setting( 'ds-api-plugin-connection-settings-group', 'egito_customer' );
	register_setting( 'ds-api-plugin-connection-settings-group', 'egito_api_key' );
	register_setting( 'ds-api-plugin-connection-settings-group', 'egito_api_secret' );

	register_setting( 'ds-api-plugin-form7-settings-group', 'egito_php_code_custom' );
	register_setting( 'ds-api-plugin-form7-settings-group', 'egito_contact7_forms_list' );
}

function egito_plugin_connection_settings_page() {
?><div class="wrap">
<h2>Ustawienia autoryzacji egito</h2>

<form method="post" action="options.php">
    <?php settings_fields( 'ds-api-plugin-connection-settings-group' ); ?>
    <?php do_settings_sections( 'ds-api-plugin-connection-settings-group' ); ?>
    <table class="form-table">

		<!--
		<tr valign="top">
	    <th colspan="2">Ustawienia konta egito</th>
		</tr>
		-->

        <tr valign="top">
        <th scope="row">Nazwa aplikacji</th>
        <td>
			<input type="text" name="egito_customer" value="<?php echo esc_attr( get_option('egito_customer') ); ?>" />.egito.pl
			<p class="description">Nazwa Twojej aplikacji egito. Nazwa aplikacji znajduje się w adresie na który logują się użytkownicy przed 'egito.pl'.</p>
		</td>
        </tr>

        <tr valign="top">
        <th scope="row">Nazwa użytkownika</th>
        <td>
			<input type="text" name="egito_user_name" value="<?php echo esc_attr( get_option('egito_user_name') ); ?>" />
			<p class="description">Nazwa użytkownika egito używanego do połączenia z API.</p>
		</td>
        </tr>

        <tr valign="top">
        <th scope="row">Hasło</th>
        <td>
			<input type="password" name="egito_password" value="<?php echo esc_attr( get_option('egito_password') ); ?>" />
		</td>
        </tr>

        <tr valign="top">
        <th scope="row">Klucz API</th>
        <td>
			<input type="text" name="egito_api_key" value="<?php echo esc_attr( get_option('egito_api_key') ); ?>" />
			<p class="description">Klucz API dostępny jest w ustawieniach aplikacji Egito.</p>
		</td>
        </tr>

        <tr valign="top">
        <th scope="row">API sekret</th>
        <td>
			<input type="text" name="egito_api_secret" value="<?php echo esc_attr( get_option('egito_api_secret') ); ?>" />
			<p class="description">API sekret dostępny jest w ustawieniach aplikacji Egito.</p>
		</td>
        </tr>

		<tr valign="top">
        <th scope="row">Status połączenia z egito.</th>
        <td>
		<p style="margin-bottom: 15px;"><?php ds_api_check_connect_status() ?></p>
		<p class="description">
			Status zostanie zaktualizowany po zapisaniu powyżsych danych.
		    <br/>Status <b>połączony</b> - oznacza że ustanowiono poprawnie połączenie z systemem egito (powyższe dane wprowadzono poprawnie)
		    <br/>Status <b>nie połączony</b> - oznacza że nie udało się nawiązać połączenia z wykorzystaniem powyżych danych, należy sprawdzić poprawność wprowadzonych danych.
		</p>
		</td>
		</tr>
    </table>
    <?php submit_button(); ?>
</form>
</div>
<?php } ?>
<?php
function egito_plugin_form_settings_page() {
?>
<div class="wrap">
<h2>Ustawienia integracji z formularzem contact 7</h2>

<form method="post" action="options.php">
    <?php settings_fields( 'ds-api-plugin-form7-settings-group' ); ?>
    <?php do_settings_sections( 'ds-api-plugin-form7-settings-group' ); ?>
    <table class="form-table">
		<tr valign="top">
        <th scope="row">Status połączenia z egito.</th>
        <td>
		<p style="margin-bottom: 15px;"><?php ds_api_check_connect_status() ?></p>
		<p class="description">
		    Status <b>połączony</b> - oznacza że ustanowiono poprawnie połączenie z systemem egito (powyższe dane wprowadzono poprawnie)
		    <br/>Status <b>nie połączony</b> - oznacza że nie udało się nawiązać połączenia z wykorzystaniem powyżych danych, należy sprawdzić poprawność wprowadzonych danych.
		</p>
		</td>
		</tr>
        <tr valign="top">
        <th scope="row">Formularz contact 7</th>
        <td>
		<?php
		$args = array('post_type' => 'wpcf7_contact_form', 'posts_per_page' => -1);
		if( $cf7Forms = get_posts( $args ) ){
			$contactFormList = get_option('egito_contact7_forms_list');
			echo '<select name="egito_contact7_forms_list[]" multiple="multiple" style="max-width: none; width: 100%" size="'.count($cf7Forms).'">';
			foreach($cf7Forms as $cf7Form){
				if (is_array($contactFormList) && in_array($cf7Form->ID, $contactFormList)) {
					echo '<option value="'.$cf7Form->ID.'" selected="selected">'.$cf7Form->post_title.'</option>';
				} else {
					echo '<option value="'.$cf7Form->ID.'">'.$cf7Form->post_title.'</option>';
				}
			}
			echo '</select>';
		}
		?>
	    <p class="description">Wybierz formularze do integracji z egito. Aby wybrać kilka formularzy przytrzymaj "ctrl" i wybierz myszką.</p>
		</td>
		</tr>

        <tr valign="top">
        <th scope="row">Kod wykonywany po zapisie formularza</th>
        <td>
		<textarea data-role="ds-code-editor" style="height: 400px;" name="egito_php_code_custom"><?php echo esc_attr( get_option('egito_php_code_custom') ); ?></textarea>
		<div data-role="ds-code-editor-container" style="height: 400px;" />
		</td>
        </tr>

		<tr valign="top">
        <th scope="row"></th>
        <td>
		<p class="description">Szczegółowy opis dzięki któremu dokonasz nawet zaawansowanych integracji znajdziesz <a target="_blank" href="https://egito.pl/api/">tutaj</a>.</p>
		</td>
		</tr>

        <tr valign="top">
        <th scope="row">Przykładowy kod integracji</th>
        <td>
		<pre>
&lt;?php
//Pobieranie danych z formularza contact form 7
//Użycie funkcji ucfirst i strtolower można wedle uznania pominąć.
$name = ucfirst($formData['your-name']);
$email = ucfirst($formData['your-email']);
$phone = strtolower($formData['your-phone']);
$surname = ucfirst($formData['your-surname']);

//Przykład warunkowego doboru id słownika
$relationshipId = '';
if ($typ == 'klient') {
  $relationshipId = 111111;
} elseif ($kategoria == 'partner') {
  $relationshipId = 2222222;
} elseif ($kategoria == 'dostawca') {
  $relationshipId = 3333333;
}

//Przykładowy kod tworzący Leada w systemie.
$leadId = ds_api_create_object('Lead', array(
	'name' => $name,
	'companyName' => $firma,
	'email' => $email,
	'description' => $opis,
	'mobilePhone.number' => $phone,
	'source' => 88888888,
	'utmCampaign' => $kod_kampanii,
	'customValues.customField' => $customValue,
));

//$leadId = ds_api_create_object('Lead', array(
//	'name' => 'Nowy lead',
//	'description' => json_encode($formData, JSON_PRETTY_PRINT),
//));

?>

//Przykładowy kod tworzący w egito obiekt Kontrahenta.
//System egito dokonuje walidacji unikalności nazw na polu name, dlatego podczas tworzenia nazwy dołożono losowy ciąg znaków
//wartości dla pól: relationshipTypeId oraz ownerId należy zweryfikować z wartościami w aplikacji do której dokonujemy integracji
//wartości użyte w poniższym kodzie należy traktować jako przykład.
//Poprawne wykonanie funkcji ds_api_create_object zwraca identyfikator utworzonego obiektu w systemie.
//Identyfikator ten możemy wykorzystać w kolejnych krokach.
//Nazwa kontrahenta egito musi być unikalna na poziomie całego systemu dlatego urzyto funkcji rand()
//aby zapewnić unikalność tworzonej nazwy - oczywiście można zapewnić unikalność w inny sposób.
$accountId = ds_api_create_object('Account', array(
	'name' => $name . " " . $surname . "[" . rand(0, 1000) . "]",
	'fullName' => $name . " " . $surname,
	'email' => $email,
	'mainPhoneNumber.number' => $phone,
	'relationshipTypeId' => '2033108',
	'ownerId' => 5956352,
	'status' => 'POTENTIAL',
));

//Przykładowy kod tworzący kontakt w systemie i podpinający ten kontakt to utworzonego w poprzednim kroku kontrahenta.
$contactId = ds_api_create_object('Contact', array(
	'name' => $name,
	'surname' => $surname,
	'email' => $email,
	'accountId' => $accountId,
	'mobilePhone.number' =>  $phone,
));
?&gt;
		</pre>
		<br/>
		Więcej informacji o integracjach znajdziesz na stronie: <a href="https://egito.pl/api/" alt="Egito API">https://egito.pl/api/</a>
		</td>
        </tr>
    </table>
    <?php submit_button(); ?>
	<script type='text/javascript' src='<?php echo plugins_url('/egito/assets/js/ace/ace.js') ?>'></script>
	<script type='text/javascript' src='<?php echo plugins_url('/egito/assets/js/ace/mode-php.js') ?>'></script>
	<script type='text/javascript' src='<?php echo plugins_url('/egito/assets/js/ace/theme-dawn.js') ?>'></script>
	<script type='text/javascript'>
        (function() {
            var $el = jQuery("[data-role='ds-code-editor-container']");
            var editor = ace.edit($el[0]);
            var textarea = jQuery('textarea[data-role="ds-code-editor"]').hide();
            editor.getSession().setValue(textarea.val());
            editor.setTheme("ace/theme/dawn");
            var Mode = require("ace/mode/php").Mode;
            var m=new Mode({pure: true});
            editor.getSession().setMode(m);
            editor.$blockScrolling = Infinity;
            editor.getSession().on('change', function(){
                textarea.val(editor.getSession().getValue());
            });
        }();
	</script>
</form>
</div>
<?php } ?>
