<?php
require_once('httpful.phar');

function ds_get_appliaction_protocol(){
	return "https://";
}

function ds_get_appliaction_url(){
	return "egito.pl";
}

function ds_get_url_json(){
	return "/services/restapi/json/";
}

function ds_api_check_connect_status(){
	$connected_status = '<span style="padding: 3px 10px; color: #FFF; background-color: green;">Połączono</span>';
	$not_connected_status = '<span style="padding: 3px 10px; color: #FFF; background-color: red;">Nie połączono</span>';
	$access_token = ds_api_get_access_token();
	if($access_token == '' || $access_token == null){
		echo $not_connected_status;
	} else {
		echo $connected_status;
	}
}

function ds_api_get_access_token(){
	$customer = esc_attr( get_option('egito_customer') );
	$username = get_option('egito_user_name');
	$password = get_option('egito_password');
	$api_key = get_option('egito_api_key');
	$api_secret = get_option('egito_api_secret');
	$username_e = $username . '@' . $customer;
	if($username == null || $username == '' || $customer == null || $customer == '' || $password == null || $password == '' || $api_key == null || $api_key == '' || $api_secret == null || $api_secret == ''){
		return null;
	}
	$url = ds_get_appliaction_protocol() . $customer . '.' . ds_get_appliaction_url() . '/oauth/token?';
	$url = $url.http_build_query(array(
	    'grant_type' => 'password',
	    'client_id' => $api_key,
	    'client_secret' => $api_secret,
		'password' => $password,
		'username' => $username_e,
	));
    $response = \Httpful\Request::post($url)->send();
    $access_token = $response->body->access_token;
	return $access_token;
}

function ds_api_create_object($moduleName, $arrayData, $dataType = 'json'){
	$moduleList = array("Account", "Contact", "Activity", "Opportunity", "Offer", "Lead", "Commission", "Invoice", "Address", "MagazineDocument", "SelectDictionary", "ServiceCard", "ServiceOrder", "Product", "Payment", "MoneyOperationDocument", "MoneyAccount", "Contract", "Project");
	$customer = esc_attr( get_option('egito_customer') );
	$creation_action_name = 'create';
	if (in_array($moduleName, $moduleList)) {
		$url = ds_get_appliaction_protocol() . $customer . '.' . ds_get_appliaction_url() . ds_get_url_json() . $moduleName . '/'. $creation_action_name;
		$response = ds_api_invoke_method($url, $arrayData, $dataType);
        if (!$response->body->id) {
            return null;
        } else {
			return $response->body->id;
		}
	} else {
		return null;
	}
}

//dataType 'json' 'query'
function ds_api_invoke_method($url, $arrayData, $dataType = 'json'){
		$access_token = ds_api_get_access_token();
		$customer = esc_attr( get_option('egito_customer') );
		$response = null;

		if($dataType == 'json'){
			$response = \Httpful\Request::post($url)
				->sendsJson()
				->body(json_encode($arrayData))
				->addHeader('Authorization', 'Bearer ' . $access_token)
				->send();
		}
		if($dataType == 'query'){
			$response = \Httpful\Request::post($url)
				->body(http_build_query($arrayData))
				->addHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8')
				->addHeader('Authorization', 'Bearer ' . $access_token)
				->send();
		}
		return $response;
}

function ds_contactform7_before_send_email($form_to_DB)
{
    $submission = WPCF7_Submission::get_instance();
	$contactFormList = get_option('egito_contact7_forms_list');
	$access_token = ds_api_get_access_token();
    if ($submission) {
        $formData = $submission->get_posted_data();
        $form_id = $formData['_wpcf7'];
        if ($form_id == null) {
	        $form_id = WPCF7_ContactForm::get_current()->id(); // $_POST['_wpcf7']
        }
		if (is_array($contactFormList){
			if(in_array($form_id, $contactFormList)) {
//				foreach($formData as $formDataKey => $formDataValue){
	//				${$formDataKey} = $formDataValue;
		//		}
				eval('?> ' . get_option('egito_php_code_custom') . ' <?php ');
			} else {
				return null;
			}
		} else {
			return null;
		}
	}
}

remove_all_filters('wpcf7_before_send_mail');
add_action('wpcf7_before_send_mail', 'ds_contactform7_before_send_email');
